;
;     Free DOS Alternative Kernel;  FDBOOT v. 1.00 (06-20-95)
;
;     =        Miscellaneous bootstrap defenitions          =
;
;     by Yury Semenov (yury@petre.odessa.ua, Fidonet#2:467/2)
;

DRV_TRY      EQU 3    ; Maximum tries to read sector

SHIFT_STATUS EQU 417h ; BIOS Data: Shift Status
TIMER_LOW    EQU 46ch ; BIOS Data: Timer (low word)

BOOTR      Struc                  ; Boot Record description
  OEM		DB "        "
  SectSz        DW 0
  ClustSz       DB 0
  ResSec	DW 0
  FATCnt	DB 0
  RootDirEnt	DW 0
  TotSec	DW 0
  Media		DB 0
  FATSz		DW 0
  TrkSec	DW 0
  Heads		DW 0
  Hidden	DD 0
  TotSecLong	DD 0
  PhysDrive	DW 0
  ExtBoot	DB 0
  SerialNo	DD 0
  VolumeID	DB "           "
  FileSysID	DB "        "
BOOTR      Ends

DIRENT     Struc                  ; Directory Entry description
  F_name        DB "        "
  F_ext         DB "   "
  F_attr        DB 0
  F_reserved    DB 10 DUP(0)
  F_time        DW 0
  F_date        DW 0
  F_cluster     DW 0
  F_size        DD 0
DIRENT     Ends

putc	MACRO ch
        mov	ax,0e00h OR ch
        int	10h
        ENDM

put_al	MACRO
        mov	ah,0eh
        int	10h
        ENDM

IFNDEF BUILTIN_RETF
 retn	MACRO
	 DB	0C3h
        ENDM

 retf	MACRO
	 DB	0CBh
        ENDM
ENDIF

LOADED      EQU 7c00h             ; Code will be loaded to address 0:LOADED
XBOOTADDR   EQU LOADED + 200h     ; Here we'll load XBoot.Sys
XBOOTSTART  EQU XBOOTADDR+4       ; XBoot legal entry point
DIRWIN      EQU 500h              ; Directory Window
DATAWIN     EQU 700h              ; Data Window
SUBDIR      EQU 10h               ; DIR \  Non-regular File Attributes
VOLUME      EQU 8                 ; VOL /

KERNEL SEGMENT AT 70h
ASSUME CS:KERNEL
 KERNEL_ENTRY LABEL FAR
KERNEL ENDS

FDBOOTDATA   EQU LOADED + 50h

CurrentLS    EQU dword ptr [bp]   ; Current logical Sector
CurrentLS_hi EQU word ptr [bp+2]  ;                        high word  
CurrentLS_lo EQU word ptr [bp]    ;                        low  word
DataStart    EQU dword ptr [bp+4] ; Cluster 2 offset
DataStart_hi EQU word ptr [bp+6]  ;                        high word
DataStart_lo EQU word ptr [bp+4]  ;                        low  word
KernOfs      EQU word ptr [bp+8]  ; Pointer to Default Kernel directory entry
XBStart      EQU word ptr [bp+10] ; XBOOT.SYS starting cluster
